#include <bits/stdc++.h>

using namespace std;

int main()
{
    short int q,i,n,k,bon,bzn,bot,bzt,bop,bzp,x,j,l;
    bool kt;
    long long int t;
    scanf("%hi",&q);
    string z[q],p;
    for(i=0;i<q;i++)
    {
        scanf("%hi %hi %lli",&n,&k,&t);
        if((t>(int)pow(2,n))||(n%2==1&&k==0))
        {
            z[i]="Ne postoji";
            continue;
        }
        bon=n;
        bzn=0;
        for(j=0;j<n;j++)
        {
            z[i]+="(";
        }
        if(n==k&&t==1)
        {
            continue;
        }
        for(j=0;j<t!=0;j++)
        {
            for(l=0;z[i][l]==')'&&l<n;l++);
            if(l==n&&t==1&&k==n)
            {
                break;
            }
            if(l==n&&(t>1||k<n))
            {
                z[i]="Ne postoji";
                break;
            }
            for(l=0;z[i][l]==')';l++)
            {
                z[i][l]='(';
                bon++;
                bzn--;
            }
            z[i][l]=')';
            bzn++;
            bon--;
            if(abs(bon-bzn)>k)
            {
                continue;
            }
            p=z[i];
            bot=0;
            bzt=0;
            bop=bon;
            bzp=bzn;
            x=n;
            kt==false;
            bot=0;
            bzt=0;
            for(l=0;l<x;l++)
            {
                if(p[l]=='(')
                {
                    bot++;
                }
                if(p[l]==')')
                {
                    bzt++;
                }
                if(bzt>bot)
                {
                    p[l].erase(p.begin()+l);
                    bzt--;
                    bzp--;
                    k--;
                    x--;
                }
            }
            for(l=0;l<x;l++)
            {
                if(p[x-1-l]=='(')
                {
                    bot++;
                }
                if(p[x-1-l]==')')
                {
                    bzt++;
                }
                if(bot>bzt)
                {
                    p[l].erase(p.end()-l);
                    bot--;
                    bop--;
                    k--;
                    x--;
                }
            }
            if(p.empty())
            {
                kt=true;
            }
            if(bzp==bop)
            {
                kt=true;
            }
            if(k<0)
            {
                kt=false;
            }
            if(kt)
            {
                t--;
            }
        }
    }
    return 0;
}